/*
 *   uTools.dll v2b36
 *   Copyright (C) 2001 Lathiat
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 */

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#define retOK(msg) sprintf(data,"S_OK %s",msg); return 3;
#define retERR(msg) sprintf(data,"S_ERR %s",msg); return 3;
typedef struct {
    DWORD  mVersion;
    HWND   mHwnd;
    BOOL   mKeep;
} LOADINFO;
HMENU hMenu = 0;

extern "C" __declspec(dllexport) void __stdcall LoadDll(LOADINFO *lInfo);
extern "C" __declspec(dllexport) int __stdcall UnloadDll(int TimeOut);
extern "C" __declspec(dllexport) int __stdcall KMBhwnd(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause);
extern "C" __declspec(dllexport) int __stdcall SetMircTitle(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause);
extern "C" __declspec(dllexport) int __stdcall GetMircTitle(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause);
extern "C" __declspec(dllexport) int __stdcall GetTitle(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause);
extern "C" __declspec(dllexport) int __stdcall ToggleBar(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause);
extern "C" __declspec(dllexport) int __stdcall MenuBarState(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause);
extern "C" __declspec(dllexport) int __stdcall DLLInfo(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause);

int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*) { return 1; }
void __stdcall LoadDll(LOADINFO *lInfo) {
}
int __stdcall UnloadDll(int TimeOut) { return 0; }
int __stdcall KMBhwnd(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
  SetMenu((HWND)atol(data), NULL);
  retOK("HIDDEN");
}
int __stdcall SetMircTitle(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
  SetWindowText(mWnd, data);
  retOK("");
}
int __stdcall GetMircTitle(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
  char windowtext[901];
  GetWindowText(mWnd,windowtext,900);
  retOK(windowtext);
}
int __stdcall GetTitle(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
  char windowtext[901];
  GetWindowText((HWND)atoi(data),windowtext,900);
  retOK(windowtext);
}
int __stdcall ToggleBar(HWND mWnd,HWND aWnd,char *data,char *parms,BOOL Show,BOOL Nopause) {
  if (!hMenu) {
    hMenu = GetMenu(mWnd);
    SetMenu(mWnd,0);
    retOK("HIDDEN");
  }
  else {
	SetMenu(mWnd,hMenu);
	hMenu = 0;
    retOK("SHOWN");
  }
}
int __stdcall MenuBarState(HWND mWnd,HWND aWnd,char *data,char *parms,BOOL Show,BOOL Nopause) {
  if (!hMenu) {
    retOK("SHOWN");
  }
  else {
    retOK("HIDDEN");
  }
}
int __stdcall DLLInfo(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
  retOK("uTools.dll v2b36 by Lathiat<Lathiat@subdimension.com>");
}

